<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml; charset=utf-8" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<link rel="stylesheet" type="text/css" href="sqlinguae.css"  />
<?php

include ('config.php'); // charge les paramètres de configuration

// Charger les chaînes de l'interface multilingue 
// > création de l'Array global $sqlng_str
include ('lang/' . $sqlng_conf['def_lang'] . '.php' );


echo '<title>SqLinguae : ', $sqlng_str[25], '</title>';

?>

</head>

<body>
<div id="sqlng_std">
<?php

// ==================================
// == Gestion du mot de passe        
// ==================================

// Récupération du mot de passe entré par l'utilisateur
if (isset($_POST['userpsw']))
    {
    $userpsw = $_POST['userpsw'];
    }
// Aucun mot de passe transmis > on affiche le formulaire de saisie du mot de passe
else
    {
    writeformmdp();
    die('</div></body></html>');
    }


// Comparaison du mot de passe transmis avec le mot de passe préétabli

if (strtolower($userpsw) != strtolower($sqlng_conf['stat_psw']))
    {
    writeformmdp();
    // Message : "mot de passe incorrect"
    die('<p class="warn" style="text-align:center">' . $sqlng_str[23] . '</p></div></body></html>');
    }


// ================================================
// === Récupérer les autres paramètres transmis    
// ================================================

$sortorder1 = (isset($_POST['sortorder1']))? htmlspecialchars($_POST['sortorder1']) : 'recent' ;
$sortorder2 = (isset($_POST['sortorder2']))? htmlspecialchars($_POST['sortorder2']) : 'alpha' ;
$fstat = (isset($_POST['fstat']))? htmlspecialchars($_POST['fstat']) : '' ;



echo '<h1>', $sqlng_str[25], '</h1>';

// ==================================================
// === Formulaire de rafraichissement des données    
// ==================================================

echo '<form method="post" action=""><fieldset>
<input type="hidden" value="', $userpsw, '" name="userpsw" />';

// ---------------------------------
// --- Bouton de rafraichissement   
// ---------------------------------

echo'<table><tr><td><input type="submit" value=" ', $sqlng_str[30], ' " /></td>';

// ------------------------------------------------
// --- liste de choix du fichier de stat           
// ------------------------------------------------

echo'<td colspan="5" style="padding-bottom:10px"><b>', $sqlng_str[7], '</b> <select name="fstat" onChange="this.form.submit();">
<option value="">', $sqlng_str[4], '</option>', "\n"; // (choisir...)

// Lister le répertoire des fichiers de stat
$repstat = opendir('../../sqlinguae/stat/');

while($f = readdir($repstat))
    {
    if($f[0] == 's') // élimine '.', '..' et '.htaccess'
        {
    	// Vérifier que le dico associé existe toujours
        if (file_exists('../../sqlinguae/dic/' . substr($f, 5)))
            {           
            echo '<option value="', $f, '"';
            echo ($f == $fstat) ? ' selected="selected">' : '>';
            echo substr($f, 5), '</option>';
            }
        }
    }
closedir($repstat);

echo '</select></td></tr>';


// ----------------------------
// --- Choix du tri            
// ----------------------------

echo'
<tr><td>&nbsp;</td><td>&nbsp;</td><td>', $sqlng_str[27], '</td><td>', $sqlng_str[28], '</td><td>', $sqlng_str[29],'</td><td>', $sqlng_str[55], '</td></tr>
<tr><td style="text-align:left"><label><b>', $sqlng_str[26],' </b></label></td><td>:</td>

<td><input type="radio" name="sortorder1" value="alpha" ';
echo ($sortorder1 == 'alpha') ? 'checked="checked"' : '';
echo ' /></td>

<td><input type="radio" name="sortorder1" value="nb" ';
echo ($sortorder1 == 'nb') ? 'checked="checked"' : '';
echo ' /></td>

<td><input type="radio" name="sortorder1" value="echec" ';
echo ($sortorder1 == 'echec') ? 'checked="checked"' : '';
echo ' /></td>

<td><input type="radio" name="sortorder1" value="recent" ';
echo ($sortorder1 == 'recent') ? 'checked="checked"' : '';
echo ' /></td>

</tr>
<tr><td style="text-align:left"><label><b>', $sqlng_str[68],' </b></label></td><td>:</td>

<td><input type="radio" name="sortorder2" value="alpha" ';
echo ($sortorder2 == 'alpha') ? 'checked="checked"' : '';
echo ' /></td>

<td><input type="radio" name="sortorder2" value="nb" ';
echo ($sortorder2 == 'nb') ? 'checked="checked"' : '';
echo ' /></td>

<td><input type="radio" name="sortorder2" value="echec" ';
echo ($sortorder2 == 'echec') ? 'checked="checked"' : '';
echo ' /></td>

<td><input type="radio" name="sortorder2" value="recent" ';
echo ($sortorder2 == 'recent') ? 'checked="checked"' : '';
echo ' /></td>

</tr></table>';

echo '</fieldset></form>';



// ================================
// === Ecrire les stats du dico    
// ================================

if ($fstat)
    {
    writeStatDico($fstat, $sortorder1, $sortorder2);
    }



// ----------------------------------------------------------
// --- Lien vers le script + contrôle de version + manuel    
// ----------------------------------------------------------
echo '<hr />
<p>', $sqlng_str[19], ' <b><a href="http://linguae.stalikez.info">SqLinguae</a></b>, ', $sqlng_str[20], '</p>
<p><a href="chkversion.php">', $sqlng_str[58], '</a></p>
<p><a href="../manuel_fr.htm">', $sqlng_str[61], '</a></p>';



// =============================================================================
function writeStatDico($fstat, $sortorder1, $sortorder2)
    {
    
    global $sqlng_str; // Array des chaînes de langue
    
    // --- Connexion au fichier de stats du dico concerné
    $db = new PDO('sqlite:../../sqlinguae/stat/' . $fstat, '', '');
    
    // --- Calculer le nombre total des recherches effectués dans le dico
    $tot = $db->query('SELECT SUM(nb) FROM Queries');
    $tot = $tot->fetch();
    $tot = $tot[0];
     
     
    // ------------------------------------------------------
    // --- Récupérer les données de recherche triées         
    // ------------------------------------------------------
    
    $res_max = 200;
    
    // --- Table de traduction des libellés des paramètres en libellés SQL
    $sort2sql = Array(
                      'alpha' => 'word',
                      'nb' => 'nb DESC',
                      'echec' => 'success', 
                      'recent' => 'date DESC' 
                       );
    
    // Compter les motifs recherchés, sans limitation    
    $res = $db->query('SELECT COUNT(nb) FROM Queries');
    $nbtot_res = $res->fetch();
    $nbtot_res = $nbtot_res[0];
    
    
    // Extraire les résultats, avec limitation
    $res = $db->query('SELECT * FROM Queries
                       ORDER BY ' . $sort2sql[$sortorder1] . ', ' . $sort2sql[$sortorder2] .'
                       LIMIT ' . $res_max );
    $res = $res->fetchAll(PDO::FETCH_ASSOC);
    $nb_res = count($res);
    
    
    // -----------------------------------------------
    // --- Extraction du nom convivial du dico        
    // -----------------------------------------------
    
    // Connexion  à la base-dico sqlite pour extraire le nom convivial.
    // S'il est absent, on utilise le nom de fichier sans son extension
    
    $fdic = substr($fstat, 5);
    $db = new PDO('sqlite:../../sqlinguae/dic/' . $fdic, '', '');        
    $prps = $db->query('SELECT dicName FROM Properties');   
    $prps = $prps->fetch(PDO::FETCH_ASSOC);
    
    $t = $prps['dicName'];
    $t = ($t) ? htmlspecialchars($t) : substr($fdic, 0, strrpos($fdic, '.'));
    
    
    // ----------------------------------------------------
    // --- Ecrire les résultats pour le dico concerné      
    // ----------------------------------------------------
    
    // Nombre total de recherches
    echo '<hr /><h2>', $t, '</h2>    
    <p><b>', $tot, '</b> ', $sqlng_str[31];
    
    // Nombre de motifs enregistrés
    echo ' <b>', $nbtot_res, '</b> ', $sqlng_str[70];
    
    // Message "(affichées)"
    if ($nbtot_res != $nb_res)
                {
                echo ' (<b>', $nb_res, '</b> ', $sqlng_str[69], ") </p>\n";
                }
    else
                {
                echo "</p>\n";
                }
    
    echo'<table><tr><td><b>', $sqlng_str[32], '</b></td><td><b>', $sqlng_str[33], '</b></td><td><b>', $sqlng_str[54], '</b></td></tr>';
    
    foreach ($res as $r)
        {    
        switch($r['success'])
            {
            case 0:
                echo '<tr class="nosuccess">';
                break;
            case 1:
                echo '<tr>';
                break;
            case 2:
                echo '<tr class="success2">';
                break;
            }
        
        echo '<td>' . $r['word'] . '</td><td>' . $r['nb'] . '</td><td>' . $r['date'] . '</td></tr>';
        }
    
    echo '</table><br />';
    
    }


// =============================================================================
function writeformmdp()
    {
    // Affichage du formulaire de demande du mot de passe
    
    global $sqlng_str; // Array des chaînes de langue
    
    echo '
    <form method="post" action=""><fieldset>
    <div style="text-align:center">
      <p>', $sqlng_str[22], '</p>
      <input type="password" name="userpsw" />
      <input type="submit" value="Ok" />
    </div>
    </fieldset></form>';
    }
    

?>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
<p>&nbsp;</p>
</div>
</body>
</html>